#include <opencv2/opencv.hpp>

static void pyrDownMeanSmooth(const cv::Mat& in, cv::Mat& out)
{
  out.create(cv::Size(in.size().width / 2, in.size().height / 2), in.type());

  for(int y = 0; y < out.rows; ++y)
  {
    for(int x = 0; x < out.cols; ++x)
    {
      int x0 = x * 2;
      int x1 = x0 + 1;
      int y0 = y * 2;
      int y1 = y0 + 1;

      out.at<float>(y, x) = ( in.at<float>(y0, x0) + in.at<float>(y0, x1) + in.at<float>(y1, x0) + in.at<float>(y1, x1) ) * 0.25f;
    }
  }
}
